import { J as Json, O as ObjectStorage, L as LogHandlerOptions, cR as LogMessage, a as LogHandler } from './uuid-25290f9a.js';
export { dr as ArgumentsType, cj as AsyncMutex, cE as AsyncReturnType, V as BinInput, c$ as Channel, c_ as ChannelMessageEvent, dd as CryptoEncoder, as as DAY_MS, aP as Day, au as DayInput, aO as DayInputLegacy, at as DayValue, aV as DecimalInput, aU as DecimalValue, d5 as DefaultListener, c9 as Disposable, c8 as Disposer, c7 as DisposerFunction, d6 as Emitter, d3 as EmitterAllHandler, d2 as EmitterHandler, da as Encoder, J as Json, dc as JsonEncoder, d4 as ListenerSignature, d0 as LocalChannel, a as LogHandler, L as LogHandlerOptions, c as LogLevel, cO as LogLevelAlias, cP as LogLevelAliasKey, cQ as LogLevelAliasType, cR as LogMessage, cN as Logger, cU as LoggerConsoleHandler, cT as LoggerContext, cS as LoggerContextInterface, b as LoggerInterface, cZ as LoggerMemoryHandler, dN as MemStorage, dM as MemStorageOptions, dg as Message, de as MessageAction, dk as MessageDefinitions, dl as MessageHub, df as MessageResult, di as MessagesDefaultMethods, dj as MessagesMethods, dh as MessagesOptions, ci as Mutex, dR as NestedArray, db as NoopEncoder, O as ObjectStorage, cs as Pool, co as PoolTask, cq as PoolTaskEvents, cm as PoolTaskFn, cp as PoolTaskIdConflictResolution, cn as PoolTaskState, b3 as Primitive, dp as PubSub, du as RPCFn, dt as RPCOptions, dv as RPCReturn, ao as RenderMessagesOptions, ds as ReturnType, bC as RoundingMode, cH as SerialQueue, bN as SortableItem, cG as TaskEvents, cF as TaskFn, a8 as Uint8ArrayToHexDump, a7 as Uint8ArrayToJson, Y as Uint8ArrayToString, ce as UseDefer, cb as UseDispose, c6 as XRX, W as _decodeUtf8Polyfill, _ as _encodeUtf8Polyfill, E as arrayAvg, F as arrayBatches, t as arrayEmptyInPlace, q as arrayFilterInPlace, l as arrayFlatten, m as arrayIntersection, w as arrayIsEqual, B as arrayMax, C as arrayMin, j as arrayMinus, A as arrayRandomElement, o as arrayRemoveElement, p as arraySetElement, y as arrayShuffle, z as arrayShuffleForce, x as arrayShuffleInPlace, u as arraySorted, v as arraySortedNumbers, D as arraySum, n as arraySymmetricDifference, s as arrayToggleInPlace, k as arrayUnion, i as arrayUnique, bp as avg, bn as between, c0 as cloneJsonObject, b$ as cloneObject, by as cmp, bx as composeOrderby, G as createArray, d1 as createLocalChannelPair, ct as createPromise, dm as createPromiseProxy, h as csv, aT as dateStringToDays, aS as day, ax as dayDay, aN as dayDiff, aB as dayFromAny, aD as dayFromDate, aE as dayFromDateGMT, aI as dayFromParts, aJ as dayFromString, aG as dayFromTimestamp, aA as dayFromToday, aw as dayMonth, aK as dayMonthStart, aM as dayOffset, az as dayToDate, aC as dayToDateGMT, ay as dayToParts, aH as dayToString, aF as dayToTimestamp, av as dayYear, aL as dayYearStart, cJ as debounce, aW as decimal, aZ as decimalCentsPart, aX as decimalFromCents, aY as decimalToCents, K as decodeBase16, N as decodeBase32, Q as decodeBase58, S as decodeBase62, U as decodeBase64, g as decrypt, a_ as deepEqual, b0 as deepMerge, a$ as deepStripUndefinedInPlace, e as deriveKeyPbkdf2, dI as detect, d as digest, b_ as empty, I as encodeBase16, M as encodeBase32, P as encodeBase58, R as encodeBase62, T as encodeBase64, bU as encodeQuery, f as encrypt, bP as endSortWeight, bW as ensureKey, bX as ensureKeyAsync, a5 as equalBinary, b1 as escapeHTML, bB as escapeRegExp, dz as fetchBasic, dA as fetchJson, dE as fetchOptionsBasicAuth, dC as fetchOptionsFormURLEncoded, dD as fetchOptionsJson, dB as fetchText, ar as fixBrokenUth8String, aQ as forEachDay, c3 as forTimes, ap as formatMessages, dP as formatMilliseconds, a4 as fromBase64, ac as fromCamelCase, a1 as fromHex, dH as getGlobal, cK as getGlobalContext, d7 as getGlobalEmitter, cM as getGlobalLogger, cV as getNamespaceFilterString, dG as getNavigator, bi as getSecureRandom, bj as getSecureRandomIfPossible, dO as getTimestamp, dF as getWindow, dx as httpMethod, cv as immediate, b6 as isArray, bc as isBoolean, dJ as isBrowser, bE as isEven, bD as isHalf, ba as isInteger, cL as isLocalHost, bd as isNullOrUndefined, b9 as isNumber, b4 as isObject, br as isPrime, bq as isPrimeRX, b5 as isPrimitive, cC as isPromise, b7 as isRecord, bb as isSafeInteger, b8 as isString, cz as isTimeout, be as isUint8Array, $ as joinToUint8Array, bh as jsonStringify, bg as jsonStringifySafe, bf as jsonStringifySorted, a6 as jsonToUint8Array, bZ as last, d9 as lazyListener, bS as linkifyPlainText, c1 as memoize, c2 as memoizeAsync, d8 as messages, bQ as moveSortWeight, bv as objectIsEmpty, bt as objectMap, bu as objectMergeDisposable, dy as parseBasicAuth, dQ as parseDate, cX as parseLogLevel, bw as parseOrderby, bV as parseQuery, dK as platform, cD as promisify, e1 as qid, bk as randomBoolean, bm as randomFloat, bl as randomInt, r as randomUint8Array, c5 as regExpEscape, c4 as regExpString, aq as renderMessages, bG as roundDown, bJ as roundHalfAwayFromZero, bK as roundHalfDown, bL as roundHalfEven, bI as roundHalfOdd, bM as roundHalfTowardsZero, bH as roundHalfUp, bF as roundUp, bs as seededRandom, bY as size, cu as sleep, bR as sortedItems, bz as sortedOrderby, bO as startSortWeight, ad as stringToBoolean, af as stringToFloat, ae as stringToInteger, X as stringToUInt8Array, e4 as suid, e3 as suidBytes, e6 as suidBytesDate, e5 as suidDate, bo as sum, cI as throttle, cx as timeout, cw as timeoutReached, cy as timoutError, a2 as toBase64, a3 as toBase64Url, an as toBool, a9 as toCamelCase, aa as toCapitalize, ab as toCapitalizeWords, ak as toFloat, a0 as toHex, bT as toHumanReadableUrl, al as toInt, am as toString, Z as toUint8Array, bA as toValidFilename, aR as today, cA as tryTimeout, e0 as uname, b2 as unescapeHTML, cl as useAsyncMutex, H as useBase, cd as useDefer, ca as useDispose, cc as useDisposer, ch as useEventListener, dL as useExitHandler, cg as useInterval, cY as useLevelFilter, dn as useMessageHub, ck as useMutex, cW as useNamespaceFilter, cr as usePool, dq as usePubSub, dw as useRPC, cf as useTimeout, dU as uuid, d$ as uuid32Decode, d_ as uuid32Encode, dT as uuid32bit, dZ as uuidB32, dS as uuidBytes, dX as uuidDecode, dY as uuidDecodeV4, dV as uuidEncode, dW as uuidEncodeV4, e2 as uuidv4, ag as valueToBoolean, ai as valueToFloat, ah as valueToInteger, aj as valueToString, cB as waitOn } from './uuid-25290f9a.js';

interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
declare function parseArgs(config?: ParseConfig): Record<string, any>;

/** Copy string to clipboard */
declare function pbcopy(data: string): Promise<unknown>;

declare type csvOptions = {
    /** @deprecated will probably be replaced by logLevel */
    debug?: boolean;
    path?: string;
    filename?: string;
    encoding?: BufferEncoding;
    prefix?: string;
    env?: Record<string, string>;
};
/**
 * Return a path relative to the current working directory
 */
declare function stringToPath(value?: string, defaultValue?: string): string;
declare function valueToPath(value?: any, defaultValue?: string): string;
declare const toPath: typeof valueToPath;
declare function getEnvVariableRelaxed(name: string, env?: NodeJS.ProcessEnv): string | undefined;
/** Populates process.env from .env file. */
declare function setupEnv(options?: csvOptions): {
    parsed: Record<string, string>;
    error?: undefined;
} | {
    error: unknown;
    parsed?: undefined;
};

interface FileStorageOptions {
    pretty?: boolean;
    path?: string;
    extension?: string;
    objectFromString?: (data: string) => any;
    objectToString?: (data: any) => string;
    keyToFilename?: (key: string) => string;
}
declare class FileStorage<T = Json> implements ObjectStorage<T> {
    private store;
    private dirname;
    private fileKeys?;
    private pretty;
    private extension;
    private extensionLength;
    private objectFromString;
    private objectToString;
    private keyToFilename;
    constructor(opt?: FileStorageOptions);
    setItem(key: string, value: T): void;
    getPath(key: string): string;
    getBuffer(key: string): Buffer;
    getItem(key: string): T | undefined;
    removeItem(key: string): void;
    clear(): void;
    allKeys(): string[];
}

declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function ensureFolder(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function writeText(path: string, content: string): Promise<void>;

declare function LoggerFileHandler(path: string, opt?: LogHandlerOptions): (msg: LogMessage) => void;

declare function colorString(text: string, colorCode: number): string;
declare function colorStringList(list: Array<any>, style: string, bold?: boolean): any[];
declare const loggerStackTraceDebug = "loggerStackTraceDebug-7d38e5a9214b58d29734374cdb9521fd964d7485";
declare function LoggerNodeHandler(opt?: LogHandlerOptions): LogHandler;

declare function getStackLlocationList(stack: string): any[];
/**
 * Get the source code location of the caller
 * https://stackoverflow.com/a/47296370/140927
 *
 * @param level Number of levels to go down the stack trace
 * @param stripCwd Strip the current working directory, only reasonable for Node.js environment
 * @returns
 */
declare function getSourceLocation(level?: number, stripCwd?: boolean): string;
declare function getStack(): string;
declare function getSourceLocationByPrecedingPattern(patterns: string[], stripCwd?: boolean): string;

export { FileStorage, FileStorageOptions, LoggerFileHandler, LoggerNodeHandler, colorString, colorStringList, ensureFolder, exists, getEnvVariableRelaxed, getSourceLocation, getSourceLocationByPrecedingPattern, getStack, getStackLlocationList, loggerStackTraceDebug, parseArgs, pbcopy, readText, removeFolder, setupEnv, stringToPath, toHumanReadableFilePath, toPath, valueToPath, writeText };
